<?php
defined('CONF_URL_APP') or die;

class Mensaje extends ItemModel
{
	protected $dbt_const = "DBT_MENSAJES";
	protected $dbt = "mensajes";
	
	protected $ext_folder = "ext_mensajes";
	protected $ext_vista_categoria = "categoria_mensajes";
	protected $ext_vista_item = "mensaje";
	
	protected $ext_item_class = "Mensaje";
	protected $ext_categoria_class = "MensajeCategoria";
	protected $ext_item_campoextra_class = "MensajeCampoExtra";
	
	protected $all_vars = array("id","titulo","alias","contenido","fecha","fecha_publicacion","estado","imagen_destacada","categorias","creador","creador_alias","propietario","params","tags","idioma","lugar","direccion","codigo_postal","localidad","provincia","pais","latitud","longitud","acceso","destinatarios","padre","id_original","adjunto");
	
	protected $idx_vars = array("id");
	protected $update_vars = array("titulo","alias","contenido","fecha_publicacion","estado","imagen_destacada","categorias","creador","creador_alias","propietario","params","tags","idioma","lugar","direccion","codigo_postal","localidad","provincia","pais","latitud","longitud","acceso","destinatarios","padre","id_original","adjunto");
	protected $campos_multilang = array("titulo","alias","contenido","texto_corto","lugar");
	protected $campos_array = array("params","categorias","destinatarios");
	
	protected $campo_titulo = 'titulo';
	
	private static $_instances;
	private static $_links;
	
	function __construct(){
		parent::__construct();
	}
	
	function includes(){
		c_include('loc/region','loc/provincia','loc/localidad','loc/pais','usuario');
		e_include('ext_mensajes/class/mensajeCategoria','ext_mensajes/class/mensajeEnviado');
	}
	
	function getdestinatarios($print=false, $sep=', ')
    {
        if($print==false){
       		return $this->destinatarios;
		} else {
			c_include('usuario');
			$usrs=json_decode($this->destinatarios);
			$u_array = array();
			foreach($usrs as $u){
				$u_obj = new Usuario();
				$u_obj->setid(substr($u, 1));
				if ($u_obj = $u_obj->BuscarId())
					$u_array[] = $u_obj->getnombre_completo();
			}
			
			return implode($sep, $u_array);
		}
    }
	
	function Guardar() {
        if (is_array($this->update_vars) && sizeof($this->update_vars) > 0) {
			c_include('app');
			
			$destinatarios = (array) json_decode($this->destinatarios);
			
			$destinatarios_sin_permiso = array();
			foreach ($destinatarios as $kdest=>$dest){
				if (substr($dest, 0, 1) == '-'){
					$usr_dest_id = substr($dest, 1);
				} else {
					$usr_dest_id = $dest;
				}
			
				$usr_dest = new Usuario($usr_dest_id);
				$params_usr = Helpers::toArray(json_decode($usr_dest->params));
				
				if ($params_usr['extensiones']['ext_mensajes']['permitir_recibir'] == '0'){
					$destinatarios_sin_permiso[] = $usr_dest->getnombre_completo();
					unset($destinatarios[$kdest]);
				}
			}
			
			if (count($destinatarios_sin_permiso) > 0){
				App::setMsg(sprintf(__('Algunos destinatarios del mensaje no permiten la recepción de mensajes: %s'), implode(', ', $destinatarios_sin_permiso)), 'error');
			}
			
			if (count($destinatarios) == 0){
				App::setMsg(__('¡El mensaje no tiene destinatarios!'), 'error');
				return false;
			}

            $link = new DB();
			$append_campos = '';
			$append_valores = '';
			if ($incluir_id == true){
				$append_campos .= ', ';
				$cuvars1 = 0;
				foreach ($this->idx_vars as $ivar) {
					if (!in_array($ivar, $this->update_vars)){
						$cuvars1 ++;
		
						$append_campos .= $ivar;
		
						if (count($this->idx_vars) > $cuvars1)
							$append_campos .= ", ";
						
					}
				}
				if ($cuvars1 == 0){
					$append_campos = '';
				}
				
				$append_valores .= ', ';
				$cuvars1 = 0;
				foreach ($this->idx_vars as $ivar) {
					if (!in_array($ivar, $this->update_vars)){
						$cuvars1 ++;
		
						$append_valores .= "'" . mysqli_real_escape_string($link->conn, $this->$ivar) . "'";
		
						if (count($this->idx_vars) > $cuvars1)
							$append_valores .= ", ";
						
					}
				}
				if ($cuvars1 == 0){
					$append_valores = '';
				}
				
			}
			
            $sql = "
					INSERT INTO 
								" . constant($this->get('dbt_const')) . "(
															" . implode(", ", $this->update_vars) . $append_campos . "
															)
								  
													  VALUES(";

            $cuvars = 0;
            foreach ($this->update_vars as $uvar) {
                $cuvars ++;
				
				if ($uvar == 'location' && in_array('latitud', $this->update_vars) && in_array('longitud', $this->update_vars)){
					if (empty($this->latitud)){
						$this->latitud = '0';
					}
					if (empty($this->longitud)){
						$this->longitud = '0';
					}
					$sql .= "POINT(".mysqli_real_escape_string($link->conn,$this->latitud).", ".mysqli_real_escape_string($link->conn,$this->longitud).")";
				} else {
                	$sql .= "'" . mysqli_real_escape_string($link->conn, $this->$uvar) . "'";
				}

                if (count($this->update_vars) > $cuvars)
                    $sql .= ", ";
            }
			
			$sql .= $append_valores;

            $sql .="
					)
				   ";
				   
            $res = $link->Query($sql);
			$last_msg_id = mysqli_insert_id($link->conn);
            //$link->Desconectar();
			
			if ($last_msg_id == 0 && $res == true){
				return true;
			} elseif ($res == false) {
				return false;
			} else {
           		if (!in_array($this->creador, $destinatarios)){
					$msg_enviado = new MensajeEnviado();
					$msg_enviado->setusuario_id(substr($this->creador, 1));
					$msg_enviado->setmensaje_id($last_msg_id);
					
					if ($msg_enviado->Guardar()){
					}
				}
				
				foreach ($destinatarios as $dest_usr){
					if (substr($dest_usr, 0, 1) == '-'){
						$usr_id = substr($dest_usr, 1);
					} else {
						$usr_id = $dest_usr;
					}
					
					if (!empty($usr_id)){
						$msg_enviado = new MensajeEnviado();
						$msg_enviado->setusuario_id($usr_id);
						$msg_enviado->setmensaje_id($last_msg_id);
						
						if ($msg_enviado->Guardar()){
							$usr_dest = new Usuario($usr_id);
							if ($usr_dest instanceof Usuario && $usr_dest->id == $usr_id){
								$params_usr = Helpers::toArray(json_decode($usr_dest->params));
								if ($params_usr['extensiones']['ext_mensajes']['enviar_email'] == '1'){
									$asunto = sprintf(__('Nuevo mensaje: %s'), SistemaIdioma::Imprimir($this->titulo));
									$txt = '<p>'.sprintf(__('El usuario %s te ha enviado el siguiente mensaje:'), $this->getcreador(true)).'</p>';
									$txt .= SistemaIdioma::Imprimir($this->contenido);
							
									c_include('email/email');
							
									$emailer = new Emailer();
									$to_array = array($usr_dest->getemail() => $usr_dest->getnombre_completo());
							
									$emailer->to = $to_array;
									$emailer->asunto = $asunto;
							
									$emailer->contenido = $txt;
							
									if ($emailer->enviar()) {
									} else {
										App::setMsg(sprintf(__('No se ha podido enviar la copia del mensaje por email a %s (%s)'), $usr_dest->getnombre_completo(), $usr_dest->getemail()), "error");
									}
								}
							}
						}
					}
				}
				
				return $last_msg_id;
			}
        } else {
            return false;
        }
    }
	
	public function es_destinatario(){
		if (!Usuario::isLoged())
			return false;
			
		$destinatarios = (array) json_decode($this->destinatarios);
		
		if (in_array('-'.Usuario::getLogedId(), $destinatarios))
			return true;
		else
			return false;
	}
	
	public function msgLeido($forzar=false){
		if (!Usuario::isLoged() || (!$this->es_propietario() && !$this->es_destinatario()))
			return false;
			
		if ($this->leido == '1')
			return true;
			
		if (!$forzar)
			return false;
			
		$msg_leido = new MensajeEnviado();
		$msg_leido_c = $msg_leido->ListarCount("usuario_id='".Usuario::getLogedId()."' AND mensaje_id='".$this->id."'");
		
		if ($msg_leido_c != 1){
			return false;
		} else {
			$msg_leido = $msg_leido->Listar("usuario_id='".Usuario::getLogedId()."' AND mensaje_id='".$this->id."'");
			$msg_leido = $msg_leido[0];
			
			$msg_leido->setleido(1);
			
			if ($msg_leido->Modificar()){
				return true;
			} else {
				return false;
			}
		}
	}
	
	public function msgBorrado($forzar=false, $restaurar=false){
		if (!Usuario::isLoged() || (!$this->es_propietario() && !$this->es_destinatario()))
			return false;
			
		if ($restaurar == false){
			if ($this->borrado == '1')
				return true;
		} else {
			if ($this->borrado == '0')
				return true;
		}
			
		if (!$forzar)
			return false;
			
		$msg_leido = new MensajeEnviado();
		$msg_leido_c = $msg_leido->ListarCount("usuario_id='".Usuario::getLogedId()."' AND mensaje_id='".$this->id."'");
		
		if ($msg_leido_c != 1){
			return false;
		} else {
			$msg_leido = $msg_leido->Listar("usuario_id='".Usuario::getLogedId()."' AND mensaje_id='".$this->id."'");
			$msg_leido = $msg_leido[0];
			
			if ($restaurar == false){
				$msg_leido->setborrado(1);
			} else {
				$msg_leido->setborrado(0);
			}
			
			if ($msg_leido->Modificar()){
				return true;
			} else {
				return false;
			}
		}
	}
	
	public static function cuentaNuevos($categoria=0, $incluir_subcats=false){
		if (!Usuario::isLoged())
			return false;
		
		$filtro_cat = '';
		if (!empty($categoria)){
			$ct_obj = new MensajeCategoria();
			$ct_obj->setid($categoria);
			
			if ($ct_obj = $ct_obj->BuscarId()){
				$filtro_cat = " AND categorias LIKE '%\"".$ct_obj->id."\"%'";
				
				if ($incluir_subcats){
					$cuenta_subcats = $ct_obj->ListarCount("estado=1 AND padre LIKE '%\"".$ct_obj->id."\"%'");
					
					if ($cuenta_subcats > 0){
						$subcats_obj = $ct_obj->Listar("estado=1 AND padre LIKE '%\"".$ct_obj->id."\"%'");
						
						$subcats_filtro_arr = array();
						
						foreach ($subcats_obj as $sc){
							$subcats_filtro_arr[] = "categorias LIKE '%\"".$sc->id."\"%'";
						}
						
						if (is_array($subcats_filtro_arr) && sizeof($subcats_filtro_arr) > 0){
							$filtro_cat .= " OR (".implode(" OR ", $subcats_filtro_arr).")";
						}
					}
				}
				
			}
		}
		
		$mensajes_enviados = new MensajeEnviado();
		
		$mensajes_nuevos = new Mensaje();
		
		$mensajes_nuevos = $mensajes_nuevos->Listar("estado=1 AND destinatarios LIKE '%\"-".Usuario::getLogedId()."\"%'".$filtro_cat, 'fecha', 'DESC', 0, 0, SistemaIdioma::getIdiomaSesion(), false, "", false, "leido='0' AND borrado='0'", true);

		return $mensajes_nuevos;
	}
	
	function ListarCount($where = "", $orderBy, $orderS, $limit1 = 0, $limit2 = 0, $lang, $extra_append, $borradores = false, $having='', $incluir_respuestas=false) {
        $idioma_ii = $lang;
		if (empty($idioma_ii)){
			$idioma_ii = SistemaIdioma::getIdiomaSesion();
		}
		
        $ii = new ItemsIndex();
		$left_join = ' LEFT JOIN '.constant($ii->get('dbt_const')).' ii on (i.id=ii.id_elemento_index AND ii.extension_index="'.$this->ext_folder.'" AND ii.vista_index="'.$this->ext_vista_item.'" AND ii.idioma_index="'.$idioma_ii.'")';
		
        $append = '';
        if (!empty($lang) && strlen($lang) == 2) {
            if (empty($where)) {
                $where = '(i.idioma="" OR i.idioma="' . $lang . '")';
            } else {
                $where .= ' AND (i.idioma="" OR i.idioma="' . $lang . '")';
            }
        }

        $append .= $extra_append;
		
		$mensajes_nuevos = new MensajeEnviado();
		
		$append .= ", (SELECT leido FROM ".constant($mensajes_nuevos->get('dbt_const'))." me WHERE me.mensaje_id=i.id AND usuario_id='".Usuario::getLogedId()."' ) as leido, (SELECT borrado FROM ".constant($mensajes_nuevos->get('dbt_const'))." mb WHERE mb.mensaje_id=i.id AND usuario_id='".Usuario::getLogedId()."' ) as borrado, (SELECT respondido FROM ".constant($mensajes_nuevos->get('dbt_const'))." mr WHERE mr.mensaje_id=i.id AND usuario_id='".Usuario::getLogedId()."' ) as respondido";
		
		$append .= $extra_append;
		
        $karma_orden = false;
		if ($orderBy == 'karma'){
			$karma_orden = $orderS;
			$orderBy = 'id';
			$orderS = 'DESC';
		}

        $link = new DB();
        $sql = "
				SELECT 
					COUNT(i.id) AS num" . $append . "
				FROM
					" . constant($this->dbt_const) . " i
				";
		if (!empty($left_join)){
			$sql .= $left_join;
		}
        if (($where != "")) {
            $sql .= " WHERE " . $where;
			if (in_array('id_original', $this->all_vars) && $borradores == false){
				$sql .= " AND id_original='0'";
			}
			if ($incluir_respuestas == false){
				$sql .= " AND (padre='0' OR padre='')";
			}
        } else {
			if (in_array('id_original', $this->all_vars) && $borradores == false){
				$sql .= " WHERE id_original='0'";
				if ($incluir_respuestas == false){
					$sql .= " AND (padre='0' OR padre='')";
				}
			} else if ($incluir_respuestas == false){
				$sql .= " WHERE (padre='0' OR padre='')";
			}
		}
		if (!empty($having)){
			$sql .= " HAVING ".$having;
		}
        if (($orderBy != "" && $orderS != "")) {
            $sql .= " ORDER BY " . $orderBy . " " . $orderS;
        }
        if (!($limit1 == 0 && $limit2 == 0)) {
            $sql .= " LIMIT $limit1, $limit2 ";
        }

        $res = $link->Query($sql);
        $num = $link->FetchArray($res);
        $num = $num['num'];
        $link->Desconectar();
        return $num;
    }

    function Listar($where = "", $orderBy, $orderS, $limit1 = 0, $limit2 = 0, $lang, $generar_info_items = true, $extra_append, $borradores = false, $having='', $incluir_respuestas = false) {
        $idioma_ii = $lang;
		if (empty($idioma_ii)){
			$idioma_ii = SistemaIdioma::getIdiomaSesion();
		}
		
        $ii = new ItemsIndex();
		$left_join = ' LEFT JOIN '.constant($ii->get('dbt_const')).' ii on (i.id=ii.id_elemento_index AND ii.extension_index="'.$this->ext_folder.'" AND ii.vista_index="'.$this->ext_vista_item.'" AND ii.idioma_index="'.$idioma_ii.'")';
				
		$append = '';
        if (!empty($lang) && strlen($lang) == 2) {
            if (empty($where)) {
                $where = '(i.idioma="" OR i.idioma="' . $lang . '")';
            } else {
                $where .= ' AND (i.idioma="" OR i.idioma="' . $lang . '")';
            }
        }
		
		$mensajes_nuevos = new MensajeEnviado();
		
		$append .= ", (SELECT leido FROM ".constant($mensajes_nuevos->get('dbt_const'))." me WHERE me.mensaje_id=i.id AND usuario_id='".Usuario::getLogedId()."' ) as leido, (SELECT borrado FROM ".constant($mensajes_nuevos->get('dbt_const'))." mb WHERE mb.mensaje_id=i.id AND usuario_id='".Usuario::getLogedId()."' ) as borrado, (SELECT respondido FROM ".constant($mensajes_nuevos->get('dbt_const'))." mr WHERE mr.mensaje_id=i.id AND usuario_id='".Usuario::getLogedId()."' ) as respondido";
		
		$append .= $extra_append;

        $link = new DB();
        $i = 0;
        $sql = "
				SELECT 
					*" . $append . "
					
				FROM
					" . constant($this->dbt_const) . " i ".$left_join;
        if (($where != "")) {
            $sql .= " WHERE " . $where;
			if (in_array('id_original', $this->all_vars) && $borradores == false){
				$sql .= " AND id_original='0'";
			}
			if ($incluir_respuestas == false){
				$sql .= " AND (padre='0' OR padre='')";
			}
        } else {
			if (in_array('id_original', $this->all_vars) && $borradores == false){
				$sql .= " WHERE id_original='0'";
				if ($incluir_respuestas == false){
					$sql .= " AND (padre='0' OR padre='')";
				}
			} else if ($incluir_respuestas == false){
				$sql .= " WHERE (padre='0' OR padre='')";
			}
		}
		if (!empty($having)){
			$sql .= " HAVING ".$having;
		}
        if (($orderBy != "" && $orderS != "")) {
            $sql .= " ORDER BY " . $orderBy . " " . $orderS;
        }
        if (!($limit1 == 0 && $limit2 == 0)) {
            $sql .= " LIMIT $limit1, $limit2 ";
        }
		
        $res = $link->Query($sql);
        while ($x = $link->FetchArray($res)) {
            $aux = new $this->ext_item_class();
            $a = $aux->get_classvars();
            //$a   = get_class_vars(get_class($this));
            foreach ($a as $clave) {
                if (!in_array($clave, $this->ignore_vars)) {
                    $aux->$clave = $this->filtroSalida($x[$clave]);
                }
            }
			
			$index_obj = ItemsIndex::ActualizarItemIndex($this->get('ext_folder'), $this->get('ext_vista_item'), $aux->id, $aux->idioma, false, $aux);

            if ($aux->checkAcceso()) {
				$array[$i] = $aux;
				
				$array[$i]->numero_comentarios = $x["numero_comentarios"];
				$array[$i]->numero_valoraciones = $x["numero_valoraciones"];
				$array[$i]->total_valoraciones = $x["total_valoraciones"];
				$array[$i]->media_valoracion = $x["media_valoraciones"];
				$array[$i]->karma = $x["karma"];
				$array[$i]->pais_name = $x["pais_name"];
				$array[$i]->pais_alias = $x["pais_alias"];
				$array[$i]->provincia_name = $x["provincia_name"];
				$array[$i]->provincia_alias = $x["provincia_alias"];
				$array[$i]->localidad_name = $x["localidad_name"];
				$array[$i]->localidad_alias = $x["localidad_alias"];
				$array[$i]->leido = $x["leido"];
				$array[$i]->respondido = $x["respondido"];
				$array[$i]->borrado = $x["borrado"];
				$array[$i]->getRespuestas();
				
				if ($generar_info_items == true) {
					$array[$i]->getParametros();
					$array[$i]->campos_extra = $array[$i]->getCamposExtra();
					$array[$i]->getInfo();
					$array[$i]->configLocalizacion();
				}
				
				$array[$i]->addEntidad();
				
                $i++;
            }
        }
        $link->Desconectar();
        if ($i == 0) {
            return false;
        } else {
            return $array;
        }
    }
	
	function BuscarId($lang, $where='', $extra_append) {
        if ($this->id) {
			$idioma_ii = $lang;
			if (empty($idioma_ii)){
				$idioma_ii = SistemaIdioma::getIdiomaSesion();
			}
			
			$extension_fldr = $this->ext_folder;
        	$vista_act = $this->ext_vista_item;
			$class_name = get_class($this);
			
			if (isset(self::$_instances[$extension_fldr][$class_name][$this->id])){
				return self::$_instances[$extension_fldr][$class_name][$this->id];
			}
			
			$ii = new ItemsIndex();
			$left_join = ' LEFT JOIN '.constant($ii->get('dbt_const')).' ii on (ii.id_elemento_index='.$this->id.' AND ii.extension_index="'.$this->ext_folder.'" AND ii.vista_index="'.$this->ext_vista_item.'" AND ii.idioma_index="'.$idioma_ii.'")';
			
			$mensajes_nuevos = new MensajeEnviado();
		
			$append .= ", (SELECT leido FROM ".constant($mensajes_nuevos->get('dbt_const'))." me WHERE me.mensaje_id='".$this->id."' AND usuario_id='".Usuario::getLogedId()."' ) as leido, (SELECT borrado FROM ".constant($mensajes_nuevos->get('dbt_const'))." mb WHERE mb.mensaje_id='".$this->id."' AND usuario_id='".Usuario::getLogedId()."' ) as borrado, (SELECT respondido FROM ".constant($mensajes_nuevos->get('dbt_const'))." mr WHERE mr.mensaje_id='".$this->id."' AND usuario_id='".Usuario::getLogedId()."' ) as respondido";
			
			$append .= $extra_append;

            $link = new DB();
            $i = 0;
            $sql = "
					SELECT 
						*" . $append . "
						
					FROM
						" . constant($this->dbt_const) . " i ".$left_join."
						
					WHERE
						id = " . $this->id . $where;
			
            $res = $link->Query($sql);
            $x = $link->FetchArray($res);
            $aux = new $this->ext_item_class();
            //$a    = get_class_vars(get_class($this));
            $a = $aux->get_classvars();
			$a[] = 'url';
            foreach ($a as $clave) {
                if (!in_array($clave, $this->ignore_vars)) {
                    $aux->$clave = $this->filtroSalida($x[$clave]);
                }
            }
            //$link->Desconectar();
            $aux->numero_comentarios = $x["numero_comentarios"];
            $aux->numero_valoraciones = $x["numero_valoraciones"];
            $aux->total_valoraciones = $x["total_valoraciones"];
            $aux->media_valoracion = $x["media_valoraciones"];
			$aux->karma = $x["karma"];
			$aux->pais_name = $x["pais_name"];
			$aux->pais_alias = $x["pais_alias"];
			$aux->provincia_name = $x["provincia_name"];
			$aux->provincia_alias = $x["provincia_alias"];
			$aux->localidad_name = $x["localidad_name"];
			$aux->localidad_alias = $x["localidad_alias"];
			$aux->leido = $x["leido"];
			$aux->respondido = $x["respondido"];
			$aux->borrado = $x["borrado"];
            if ($aux->checkAcceso()) {
                $aux->getParametros();
                $aux->campos_extra = $aux->getCamposExtra();
                $aux->getInfo();
                $aux->configLocalizacion();
				$aux->getRespuestas();
            } else {
                return false;
            }
            if (!isset($aux->id)) {
                return false;
            } else {
                self::$_instances[$extension_fldr][$class_name][$this->id] = $aux;
                return $aux;
            }
        } else {
            return false;
        }
    }
	
	function getRespuestas(){
		if (empty($this->id))
			return false;
			
		if (is_array($this->respuestas))
			return $this->respuestas;
			
		$respuestas = new Mensaje();
		$respuestas_c = $respuestas->ListarCount("estado='1' AND padre='".$this->id."'", "fecha", "ASC", 0, 0, SistemaIdioma::getIdiomaSesion(), '', false, '', true);
		
		if ($respuestas_c > 0){
			$this->respuestas = $respuestas->Listar("estado='1' AND padre='".$this->id."'", "fecha", "ASC", 0, 0, SistemaIdioma::getIdiomaSesion(), true, '', false, '', true);
			
			return $this->respuestas;
		} else {
			return false;
		}
	}
	
	function getFirstNoLeido(){
		if (!$this->msgLeido())
			return $this;
			
		$this->getRespuestas();
		
		if (!is_array($this->respuestas) || sizeof($this->respuestas) == 0)
			return false;
			
		foreach ($this->respuestas as $resp){
			if (!$resp->msgLeido())
				return $resp;
		}
		
		return false;
	}
	
	private function filtroEntrada($contenido) {
        return (Helpers::mres(Helpers::from_utf8($contenido)));
    }

    private function filtroSalida($contenido) {
        return (Helpers::to_utf8($contenido));
    }
}
?>