SET FOREIGN_KEY_CHECKS=0;

-- --------------------------------------------------------

-- 
-- Estructura de tabla para la tabla `#__sitios`
-- 

DROP TABLE IF EXISTS `#__mensajes`;
CREATE TABLE IF NOT EXISTS `#__mensajes` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `titulo` text NOT NULL,
  `alias` text NOT NULL,
  `contenido` text NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `fecha_publicacion` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `estado` int(1) NOT NULL DEFAULT '1',
  `imagen_destacada` text NOT NULL,
  `categorias` text NOT NULL,
  `creador` int(11) NOT NULL,
  `creador_alias` varchar(250) NOT NULL DEFAULT '',
  `propietario` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `tags` text NOT NULL,
  `idioma` varchar(2) NOT NULL,
  `lugar` text NOT NULL,
  `direccion` text NOT NULL,
  `codigo_postal` text NOT NULL,
  `localidad` text NOT NULL,
  `provincia` text NOT NULL,
  `pais` text NOT NULL,
  `latitud` text NOT NULL,
  `longitud` text NOT NULL,
  `destinatarios` text NOT NULL,
  `padre` varchar(50) NOT NULL DEFAULT '0',
  `acceso` int(11) NOT NULL DEFAULT '0',
  `id_original` int(11) NOT NULL DEFAULT '0',
  `adjunto` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

-- --------------------------------------------------------

-- 
-- Estructura de tabla para la tabla `#__sitios_categorias`
-- 

DROP TABLE IF EXISTS `#__mensajes_categorias`;
CREATE TABLE IF NOT EXISTS `#__mensajes_categorias` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `nombre` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(250) NOT NULL,
  `contenido` text NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `estado` int(1) NOT NULL DEFAULT '1',
  `padre` varchar(250) NOT NULL DEFAULT '',
  `creador` int(11) NOT NULL,
  `creador_alias` varchar(250) NOT NULL DEFAULT '',
  `imagen_destacada` text NOT NULL,
  `icono` text NOT NULL,
  `params` text,
  `idioma` varchar(5) NOT NULL,
  `acceso` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `#__mensajes_categorias` (`id`, `nombre`, `alias`, `contenido`, `fecha`, `estado`, `padre`, `creador`, `creador_alias`, `imagen_destacada`, `icono`, `params`, `idioma`, `acceso`) VALUES
(1, '{"es":"Mensajes","en":"Messages"}', '{"es":"Mensajes","en":"Messages"}', '{"es":"","en":""}', '2014-11-19 01:15:46', 1, '[""]', 0, 'Admin', '', '', '{"estilo":"","hijos_heredan_estilo":""}', '', 0);

-- --------------------------------------------------------

-- 
-- Estructura de tabla para la tabla `#__mensajes_enviados`
-- 

DROP TABLE IF EXISTS `#__mensajes_enviados`;
CREATE TABLE IF NOT EXISTS `#__mensajes_enviados` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `usuario_id` int(11) NOT NULL,
  `mensaje_id` int(11) NOT NULL,
  `leido` tinyint(1) NOT NULL DEFAULT '0',
  `respondido` tinyint(1) NOT NULL DEFAULT '0',
  `borrado` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `msj_enviados_del_ix` (`borrado`),
  KEY `msj_enviados_mes_ix` (`mensaje_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

SET FOREIGN_KEY_CHECKS=1;