<?php
/**
 * Modelo del listado de mensajes de una categoría, permite manejar los listados de mensajes de una categoría de forma fácil
 *
 * @package		Mideas.Mensajes
 * @subpackage	Model
 * @since		1.0
 */

class MensajeCategoriaModel extends ListadoModel{
	
	protected $global_main_class = 'mensajes';
	
	protected $ext_folder = 'ext_mensajes';
	
	protected $categoria_class = 'MensajeCategoria';
	protected $item_class = 'Mensaje';
	
	protected $categoria_vista = 'categoria_mensajes';
	protected $item_vista = 'mensaje';
	
	function __construct($id=''){
		parent::__construct($id);
	}
		
	public function includes(){
		//Clase requerida
		c_include('usuario');
		e_include('ext_mensajes/class/mensajeCategoria','ext_mensajes/class/mensaje');
		$tmp_ct = new $this->categoria_class();
		$tmp_it = new $this->item_class();
	}
	
	public function get_params($custom_params=array()){
		parent::get_params($custom_params);

		$params = array();
		
		if (!Usuario::isLoged())
			return false;
		
		if (!isset($GLOBALS['params_enlace_actual'])){
			$params['tipo_pagina'] = 'entrada';
		} elseif (is_array($custom_params) && sizeof($custom_params) > 0) {
			$params['tipo_pagina'] = $custom_params['tipo_pagina'];
		} else {
			$params['tipo_pagina'] = $GLOBALS['params_enlace_actual']['params']['tipo_pagina'];
		}
		
		$this->parametros['params']['tipo_pagina'] = $params['tipo_pagina'];

		switch ($params['tipo_pagina']){
			case 'entrada':
				$this->parametros['params']['having'] = 'borrado="0"';
				$this->parametros['params']['where'][] = "destinatarios LIKE '%\"-".Usuario::getLogedId()."\"%'";
				break;
			case 'salida':
				$this->parametros['params']['having'] = 'borrado="0"';
				$this->parametros['params']['where'][] = "creador = '-".Usuario::getLogedId()."'";
				break;
			case 'papelera':
				$this->parametros['params']['having'] = 'borrado="1"';
				$this->parametros['params']['where'][] = "creador = '-".Usuario::getLogedId()."' OR destinatarios LIKE '%\"-".Usuario::getLogedId()."\"%'";
				break;
			default:
				$this->parametros['params']['having'] = 'borrado="0"';
				$this->parametros['params']['where'][] = "creador = '-".Usuario::getLogedId()."' OR destinatarios LIKE '%\"-".Usuario::getLogedId()."\"%'";
				break;
		}
		
	}
}